/***************************************************************
 * Name:      wx013Main.h
 * Purpose:   Defines Application Frame
 * Author:    Salvador Pozo (salvador@conclase.net)
 * Created:   2024-12-18
 * Copyright: Salvador Pozo (https://conclase.net)
 * License:
 **************************************************************/

#ifndef WX013MAIN_H
#define WX013MAIN_H

#ifndef WX_PRECOMP
    #include <wx/wx.h>
#endif

//#include <algorithm>
#include <set>
#include <wx/uilocale.h>
#include <wx/datetime.h>
#include "wx013App.h"

class wxDateTimeFestivos2024 : public wxDateTimeHolidayAuthority
{
protected:
    virtual bool DoIsHoliday(const wxDateTime& dt) const wxOVERRIDE;
    virtual size_t DoGetHolidaysInRange(const wxDateTime& dtStart,
                                        const wxDateTime& dtEnd,
                                        wxDateTimeArray& holidays) const wxOVERRIDE;
private:
    std::set<wxDateTime> festivo = {
        {1, wxDateTime::Jan, 2024},
        {6, wxDateTime::Jan, 2024},
        {28, wxDateTime::Mar, 2024},
        {29, wxDateTime::Mar, 2024},
        {1, wxDateTime::May, 2024},
        {9, wxDateTime::May, 2024},
        {17, wxDateTime::May, 2024},
        {25, wxDateTime::Jul, 2024},
        {15, wxDateTime::Aug, 2024},
        {16, wxDateTime::Aug, 2024},
        {12, wxDateTime::Oct, 2024},
        {1, wxDateTime::Nov, 2024},
        {6, wxDateTime::Dec, 2024},
        {25, wxDateTime::Dec, 2024}
    };
};

class wx013Frame: public wxFrame
{
    public:
        wx013Frame(wxFrame *frame, const wxString& title);
        ~wx013Frame();
    private:
        enum
        {
            idMenuQuit = 1000,
            idMenuAbout
        };
        void OnClose(wxCloseEvent& event);
        void OnQuit(wxCommandEvent& event);
        void OnAbout(wxCommandEvent& event);
        void OnPaint(wxPaintEvent& event);
        DECLARE_EVENT_TABLE()
};


#endif // WX013MAIN_H
